#define VGA_SEGMENT        0xa000
#define SC_INDEX           0x3c4
#define GC_INDEX           0x3ce
#define CRTC_INDEX         0x3d4
#define DISPIO             0x3DA

#define MAP_MASK           2
#define MEMORY_MODE        4
#define GRAPHICS_MODE      5
#define MISCELLANEOUS      6
#define VRT_bit            8
#define MAX_SCAN_LINE      9
#define START_ADDRESS_HIGH 0x0c
#define UNDERLINE          0x14
#define MODE_CONTROL       0x17

typedef struct { unsigned char r,
                               g,
                               b;
               } Palette[256];

extern void setvgapalette(Palette *PalBuf);
extern void writepixel(int x, int y, unsigned char colour);
extern void set320x400mode(void);
extern void end320x400mode(void);
extern void setvispage(int page);
extern void setvispage(int page);
extern void WaitForVerticalRetrace(void);


